import { HttpMethod } from './curlTypes'
import { DocumentationOfDocument } from './docs/DocumentationOfDocument'
import Forms from './ui/Forms'

export type ConfigVarScope =
  | 'ci'
  | 'back'
  | 'admin-app'
  | 'cutomer-app'
  | 'worker'
  | 'telegramBot'

// {id: 'ui', title: 'Ui', gitSshTemplate: 'git@gitlab.com:mtbase/mtbase-ui.git', educational: false},
// {id: 'back', title: 'Back', gitSshTemplate: 'git@gitlab.com:mtbase/mtbase-back.git', educational: false},
// {id: 'app', title: 'App', gitSshTemplate: 'git@gitlab.com:mtbase/mtbase-app.git', educational: false},
// {id: 'land', title: 'Land', gitSshTemplate: 'git@gitlab.com:mtbase/mtbase-app.git', educational: false},
// {id: 'learningBaseTs', title: 'Учебный Базовый Ts', gitSshTemplate: 'git@gitlab.com:js-learning/nodets-template.git', educational: true},
// {id: 'learningReact', title: 'Учебный React', gitSshTemplate: 'git@gitlab.com:js-learning/react-template.git', educational: true},
// {id: 'learningFigma', title: 'Учебный Figma', gitSshTemplate: 'git@gitlab.com:js-learning/nodets-template.git', educational: true},

export type ConfigValue<T extends FieldType> = T extends 'string'
    ?
      string
    :
      T extends 'int' | 'float'
      ?
        number
      :
        T extends 'bigint'
        ?
          bigint
        :
          T extends 'bool'
          ?
            boolean
          :
            Date

export interface ConfigVar<T extends FieldType = 'string'> {
  name: string
  type: T,
  required: boolean,
  default: ConfigValue<T>
  needFor: string
  scopes: ConfigVarScope[]
  hidden: boolean,
  editable: boolean,
}

export interface Glossary {
  term: string
  definition: string
}

export type ProjectCategory = 'back' | 'ui' | 'app' | 'land'

export interface Command {
  projectCategory: ProjectCategory
  name: string
  command: string
  needFor: string
}

export type TKeyFieldType = 'string' | 'int' | 'bigint'
export type FieldType =
  | 'string'
  | 'int'
  | 'bigint'
  | 'float'
  | 'bool'
  | 'datetime'
  | 'date'

export type Meaning = 'img'

export enum TsTypes {
  Number = 'number',
  BigInt = 'bigint',
  String = 'string',
  Boolean = 'boolean',
  Date = 'Date',
}

export type DefaultDbValue = string | boolean | undefined

export type BaseField = {
  name: string
  title: Record<string, string>
  needFor: string
  updatable: boolean
  required: boolean
  requiredOnInput: boolean | null
  updatableByUser: boolean
  hidden?: boolean
  searchable?: boolean
  showInList: boolean
  showInCreate: boolean
  showInEdit: boolean
  showInFilter: boolean
  showInShow: boolean
  defaultDbValue: DefaultDbValue
  defaultValueExpression?: string
  defaultBackendValueExpression?: string
  sharded: boolean
}

type ScalarBaseField = BaseField & {
  category: 'scalar'
}

type IdBaseField = BaseField & {
  autoGenerated: boolean
  category: 'id'
}

type LinkMainBaseField = BaseField & {
  externalEntity: string
  category: 'link'
}

export type  PredefinedLinkedEntity = 'none' | 'file'

type NotPredefinedLinkBaseField = LinkMainBaseField & {
  predefinedLinkedEntity: 'none'
}

export type FileType = 'plain' | 'image'

type FilePredefinedLinkBaseField = LinkMainBaseField & {
  predefinedLinkedEntity: 'file'
  fileType: FileType
}

type LinkBaseField = NotPredefinedLinkBaseField | FilePredefinedLinkBaseField

// export type ConstantOnCreateDate = false | 'now'
// export type ConstantOnUpdateDate = false | 'now'

export type BaseFilter = 'equal' | 'defined' | 'not_defined'

export type Filter = BaseFilter | 'in' | 'not_in' | 'lte' | 'gte' | 'lt' | 'gt';

export type DateFilter = BaseFilter | 'lte' | 'gte' | 'lt' | 'gt';
export type DateTimeField = ScalarBaseField & {
  type: 'datetime'
  filters: DateFilter[]
  // constantOnCreate: ConstantOnCreateDate
  // constantOnUpdate: ConstantOnUpdateDate
}

export type DateField = ScalarBaseField & {
  type: 'date'
  filters: DateFilter[]
  // constantOnCreate: ConstantOnCreateDate
  // constantOnUpdate: ConstantOnUpdateDate
}

// export type ConstantOnCreateInt = false | 'currentUser'
// export type ConstantOnUpdateInt = false | 'currentUser'

// export type ConstantOnCreate = ConstantOnCreateInt | ConstantOnCreateDate
// export type ConstantOnUpdate = ConstantOnUpdateInt | ConstantOnUpdateDate

export enum NumberType {
  Base = 'base',
  Money = 'money',
}

export type IntFilter = BaseFilter | 'in' | 'not_in' | 'lte' | 'gte' | 'lt' | 'gt';
export type IntField = ScalarBaseField & {
  type: 'int'
  filters: IntFilter[]
  numberType: NumberType
  // constantOnCreate: ConstantOnCreateInt
  // constantOnUpdate: ConstantOnUpdateInt
}

export type BigIntField = ScalarBaseField & {
  type: 'bigint'
  filters: IntFilter[]
  numberType: NumberType
  // constantOnCreate: ConstantOnCreateInt
  // constantOnUpdate: ConstantOnUpdateInt
}

export type StringFilter = BaseFilter | 'in' | 'not_in';
export type BaseStringField = ScalarBaseField & {
  type: 'string'
  filters: StringFilter[]
}

export enum StringType {
  Plain = 'plain',
  Multiline = 'multiline',
  RichEdit = 'richEdit',
  Markdown = 'markdown',
  Json = 'json',
}

export type PlainStringField = BaseStringField & {
  stringType: 'plain'
}

export type MultilineStringField = BaseStringField & {
  stringType: 'multiline'
}

export type MarkdownStringField = BaseStringField & {
  stringType: 'markdown'
}

export type RichEditStringField = BaseStringField & {
  stringType: 'richEdit'
}

export type JsonStringField = BaseStringField & {
  stringType: 'json'
}

export type StringField =
  | PlainStringField
  | MultilineStringField
  | MarkdownStringField
  | RichEditStringField
  | JsonStringField

export type FloatField = ScalarBaseField & {
  type: 'float'
  filters: IntFilter[]
  numberType: NumberType
}

export type BoolField = ScalarBaseField & {
  type: 'bool'
  filters: BaseFilter[]
}

export type BigIntIdField = IdBaseField & Omit<BigIntField, 'category'>
export type IntIdField = IdBaseField & Omit<IntField, 'category'>
export type StringIdField = IdBaseField & Omit<StringField, 'category'>

export type IntLinkField = LinkBaseField & { 
  type: 'int'
  filters: IntFilter[]
}
export type BigIntLinkField = LinkBaseField & { 
  type: 'bigint'
  filters: IntFilter[]
}
export type StringLinkField = LinkBaseField & { 
  type: 'string'
  filters: StringFilter[]
}

export type ScalarField =
  | DateTimeField
  | DateField
  | IntField
  | BigIntField
  | StringField
  | FloatField
  | BoolField

export type GeneralLinkField = BigIntLinkField | IntLinkField | StringLinkField
export type EntityLinkField = GeneralLinkField & { linkCategory: 'entity' }
export type ViewLinkField = GeneralLinkField & { linkCategory: 'view' }
export type LinkField = EntityLinkField | ViewLinkField

export type ModelField = BaseField & {
  category: 'model'
  array: boolean
  model: string;
  // name: string
  // title: Record<string, string>
  // needFor: string
  // updatable: boolean
  // required: boolean
}

export type TsModelField =
  | ScalarField
  | ModelField

export type IdField = IntIdField | BigIntIdField | StringIdField

export type Field = ScalarField | LinkField | IdField | ViewLinkField

export type Multitenancy = 'none' | 'optional' | 'required'

export type BaseEntity = {
  name: string
  title: Record<string, {singular: string}>
  needFor: Record<string, string>
  materialUiIcon: string
  previewFeatures: PreviewFeature[]
}

export type BaseSavableEntity = BaseEntity & {
  // titleField: Field;
  titleField: string
  keyField: string
  // keyField: IdField;
  singleKey: boolean
  fields: Field[]
  // linkFields: LinkField[];
  uniqueConstraints: string[][]
  forms: Forms
  predefinedElements: Record<string, any>[]
  devPerefinedElements: Record<string, any>[]
  auditable: boolean
  externalSearch: boolean
  elasticOnly: boolean
  searchEnabled: boolean
  sortField: string
  creatableByUser: boolean
  updatableByUser: boolean
  removableByUser: boolean
  exportableByUser: boolean
  sortOrder: 'ASC' | 'DESC'
  multitenancy: Multitenancy
  commonElementsVisibleToAll: boolean
  title: Record<string, {singular: string, plural: string}>
  externalSearchName: string | undefined
  sharded: boolean
  isExternalSearch: boolean
  clearDBAfter: {count: number, unit: DateUnit}[]
  allowedToChange: string
  permissions: Permission[]
  pages: Page[]
  models: TsModel[]
  methods: ServiceMethod[]
  labels: string[]
}

export type Report = BaseEntity & {
  type: 'report'
  labels: string[]
}

export type Document = BaseSavableEntity & {
  type: 'document'
  deletable: boolean
  editable: boolean
  registries: string[]
  documentation: DocumentationOfDocument
}

export type Catalog = BaseSavableEntity & {
  type: 'catalog'
  deletable: boolean
  editable: boolean
}

export type TsModel = BaseEntity & {
  fields: TsModelField[]
}

export type IntegrationClientArgsModel = TsModel

export type IntegrationClientReturnModel = TsModel & {
  array: boolean
}

export type IntegrationClientQueryMethod = BaseEntity & {
  argsModel: IntegrationClientArgsModel
  returnModel: IntegrationClientReturnModel
}

export type IntegrationClient = BaseEntity & {
  type: 'integrationClient'
  models: TsModel[]
  queryMethods: IntegrationClientQueryMethod[]
}

export enum MenuItemType {
  Group = 'group',
  External = 'external',
  ExternalEnv = 'externalEnv',
  Internal = 'internal',
}

export type Page = BaseEntity & {
  type: 'page'
  link: string
  label: string
}

export type AdditionalServiceArgsModel = TsModel

export type AdditionalServiceReturnModel = TsModel & {
  array: boolean
}

export enum MethodType {
  Query = 'query',
  Mutation = 'mutation',
}

export type ServiceMethod = BaseEntity & {
  argsModel: AdditionalServiceArgsModel
  returnModel: AdditionalServiceReturnModel
  exportedToApi: boolean
  queable: boolean
  methodType: MethodType
}

export type AdditionalService = BaseEntity & {
  type: 'additionalService'
  models: TsModel[]
  methods: ServiceMethod[]
}

export type BaseMenuItem = BaseEntity & {
  type: 'menuItem'
  label: string
  debugOnly: boolean
  permissions: string[]
}

export type GroupMenuItem = BaseMenuItem & {
  itemType: MenuItemType.Group
  items: MenuItem[]
}

export type InternalMenuItem = BaseMenuItem & {
  itemType: MenuItemType.Internal
  pageName: string
  link: string
}

export type ExternalMenuItem = BaseMenuItem & {
  itemType: MenuItemType.External
  link: string
}

export type ExternalEnvMenuItem = BaseMenuItem & {
  itemType: MenuItemType.ExternalEnv
  env: string
}

export type MenuItem = GroupMenuItem | InternalMenuItem | ExternalMenuItem | ExternalEnvMenuItem

export type Role = BaseEntity & {
  type: 'role'
}

export enum PermissionType {
  Read = 'read',
  Create = 'create',
  Update = 'update',
  Delete = 'delete',
}

export type Permission = BaseEntity & {
  type: 'permission'
  permissionType: PermissionType
}

export type TelegramBot = BaseDeployment & BaseEntity & {
  type: 'telegramBot'
}

export type RestApiMethod = BaseEntity & {
  type: 'restApiMethod'
  note: string
  httpMethod: HttpMethod
  path: string
  urlExample?: string
  requestExample: Record<string, any>
  successResponseExample: Record<string, any>
  errorResponseExample: Record<string, any>
}

export type RestApi = BaseEntity & {
  type: 'restApi'
  methods: RestApiMethod[]
  path: string
  auth: boolean
}

export type MemoryAndCpu = {
  memory: string
  cpu: string
  maxOldSpaceSize: number
}

export type BaseDeployment = {
  replicas: number
  requests: MemoryAndCpu
  limits: MemoryAndCpu
}

export type Back = BaseDeployment

export type Worker = BaseDeployment & BaseEntity

export type InfoRegistryPeriod =
  | 'notPeriodic'
  | 'second'
  | 'day'
  | 'month'
  | 'year'

export type InfoRegistry = BaseSavableEntity & {
  type: 'infoRegistry'
  registrarDepended: boolean
  dimensions: Field[]
  resources: Field[]
  period: InfoRegistryPeriod
}

export type SumRegistry = BaseSavableEntity & {
  type: 'sumRegistry'
  registrarDepended: boolean
  dimensions: Field[]
  resources: Field[]
}

export type Entity = Document | Catalog | InfoRegistry | SumRegistry

export interface DeployEnvironment {
  main: boolean
  manualDeploy: boolean
  name: string
  clusterName: string
  workerClusterName: string
  branchName: string
  metricsEnabled: boolean
  host: string
  runnerTag: string
  gitlabEnvPrefix: string
}

export type Language = {
  id: string
  title: string
}

export type System = {
  name: string
  prefix: string
  needFor?: string
  configVars: ConfigVar[]
  catalogs: Catalog[]
  documents: Document[]
  infoRegistries: InfoRegistry[]
  sumRegistries: SumRegistry[]
  languages: Language[]
  defaultLanguage: string
  roles: Role[]
  menuItems: MenuItem[]
  pages: Page[]
  models: TsModel[]
  methods: ServiceMethod[]
  labels: string[]
  additionalServices: AdditionalService[]

  reports: Report[]
  telegramBots: TelegramBot[]
  deployEnvironments: DeployEnvironment[]
  commands: Command[]
  glossary: Glossary[]
  restApis: RestApi[]
  integrationClients: IntegrationClient[]
  workers: Worker[]

  back: Back
}

export type EtityType = 'catalog' | 'document' | 'infoRegistry' | 'sumRegistry'

export type PreviewFeature = never;

export type DateUnit = 'year' | 'month' | 'day' | 'hour' | 'minute';